<?

function SendReply($aReply,$toaddr,$msgbody,$msgps,$attr,$touser,$subj)
{
	GLOBAL $CONFIG;
	$fromaddr = $CONFIG->GetVar('address');
	$fromnode = strtok($fromaddr,'.');
	$frompt = strtok('.');
	$tonode = strtok($toaddr,'.');
	$topt = strtok('.');
	$text = chr(1)."INTL ".$tonode." ".$fromnode."\r";
	if ($topt) $text.= chr(1)."TOPT $topt\r";
	if ($frompt) $text.= chr(1)."FMPT $frompt\r";
	$text.= chr(1)."MSGID: $fromaddr ".rand(10000000,99999999)."\r";
	if ($aReply) $text.= chr(1).'REPLY: '.$aReply."\r";
	$text.= chr(1)."CHRS: CP866 2\r";
	$s = GetStrFromFile_param('GREET');
	$text.= ($s?$s:"Hello!")."\r\r";
	$text.= $msgbody;
	$s = GetStrFromFile_param('BYE');
	$text.= "\r\r".($s?$s:"Bye!")."\r";
	if ($msgps):
		$text.= "\rP.S.: ".$msgps."\r\r";
	endif;
	$text.= '--- Phfito Tracker on '.$CONFIG->GetVar('system');
	$text.= AddVia(false,$fromaddr);
	preg_match('/:([0-9]+)\/([0-9]+)/',$fromaddr,$m);
	preg_match('/:([0-9]+)\/([0-9]+)/',$toaddr,$t);
	$Omessage = new Pkt_message;
	$Omessage->Version = 2;
	$Omessage->OrigNode = $m[1];
	$Omessage->DestNode = $m[2];
	$Omessage->OrigNet = $t[1];
	$Omessage->DestNet = $t[2];
	$Omessage->Attr = Flag_to_FTS($attr);
	$Omessage->Cost = 30;
	$Omessage->AsciiDate = date('d M y  H:i:s');
	$Omessage->ToUser = $touser;
	$Omessage->FromUser = 'Phfito Tracker';
	$Omessage->Subject = $subj;
	$Omessage->MsgText = $text;
	PackMessageTo($Omessage,RouteMsg($toaddr));
}

function InitVsysTrack($message,$to,$origto,$transto = false)
{
	GLOBAL $CONFIG;
	if ($CONFIG->GetVar('use_vsys')):
		include_once "E_vsys.php";
		GLOBAL $VSYS;
		GLOBAL $CONFIG;
		_init_vsys();
		$VSYS->user = $message->FromUser;
		$VSYS->sysop = 'Tracker of Phfito';
		$VSYS->station = $CONFIG->GetVar('system');
		$VSYS->Macro_arr_adv['TOUSER'] = $message->ToUser;
		$VSYS->Macro_arr_adv['FROMUSER'] = $message->FromUser;
		$VSYS->Macro_arr_adv['FROMADDR'] = $to;
		$VSYS->Macro_arr_adv['ORIGTO'] = $origto;
		$VSYS->Macro_arr_adv['TRANSTO'] = $transto;
	endif;
}

function GetStrFromFile_param($param)
{
	GLOBAL $CONFIG;
	GLOBAL $VSYS;
	if (isset($VSYS)):
		if ($f = @fopen($CONFIG->GetVar('maindir').'/'.$CONFIG->GetVar('ftrack_dict'),'r')):
			$s = $VSYS->_read_file_and_match($f,$param);
			$s = $VSYS->_format_reply($s);
			$s = $VSYS->_exp_macro($s);
			if ($s) $s{0} = $VSYS->_to_upper($s{0},!$VSYS->_updown_firstchar());
			$s = convert_cyr_string($s,'k','d');
			fclose($f);
			return $s;
		else:
			return false;
		endif;
	else:
		return false;
	endif;
}

function Quote_Cludges($text,$top = true,$skip = true,$bottom = true)
{
	GLOBAL $CONFIG;
	$topcl = '';
	$botcl = '';
	$message = str_replace("\r","\r".chr(0),$text);
	$line = strtok($message,"\r");
	while($line):
		if (strcmp(substr($line,0,1),chr(0))==0) $line = substr($line,1);
		if (strcmp(substr($line,0,1),chr(1))==0):
			$topcl.= '@'.substr($line,1)."\r";
		else:
			break;
		endif;
		$line = strtok("\r");
	endwhile;
	$line = chr(0).$line;
	while($line):
		if (strcmp(substr($line,0,1),chr(0))==0) $line = substr($line,1);
		if (strcasecmp(substr($line,0,7),chr(1).'PATH: ')==0):
			$botcl.= '@'.substr($line,1)."\r";
			break;
		elseif (strcasecmp(substr($line,0,5),chr(1).'Via ')==0):
			$botcl.= '@'.substr($line,1)."\r";
			break;
		elseif (strcmp(substr($line,0,9),'SEEN-BY: ')==0):
			$botcl.= $line."\r";
		endif;
		$line = strtok("\r");
	endwhile;
	$res = '';
	if ($top) $res.= $topcl."\r";
	if ($skip):
		$s = GetStrFromFile_param('SKIP');
		$res.= ($s?$s:"[... skipped ...]")."\r\r";
	endif;
	if ($bottom) $res.= $botcl."\r";
	return $res;
}

function SendARQ($message,$to,$origto,$msgid)
{
	GLOBAL $CONFIG;
	$transto = RouteMsg($to);
	InitVsysTrack($message,$to,$origto,$transto);
	$msgbody = '';
	$s = GetStrFromFile_param('ARQGET');
	$msgbody.= ($s?$s:"Your message to $origto is arrived to my station")."\r";
	$s = GetStrFromFile_param('ARQPACK');
	$msgbody.= ($s?$s:"It was packed to $transto")."\r";
	$s = GetStrFromFile_param('QUOTE');
	$msgps = ($s?$s:"Here is your message:")."\r\r".Quote_Cludges($message->MsgText);
	SendReply($msgid,$to,$msgbody,$msgps,MSG_PVT | MSG_RRC,$message->FromUser,'ARQ - receipt');
}

function SendRRQ($message,$to,$origto,$msgid)
{
	GLOBAL $CONFIG;
	InitVsysTrack($message,$to,$origto);
	$msgbody = '';
	$s = GetStrFromFile_param('RRQ');
	$msgbody.= ($s?$s:"Your message to me delivered to my station")."\r";
	$s = GetStrFromFile_param('QUOTE');
	$msgps = ($s?$s:"Here is your message:")."\r\r".Quote_Cludges($message->MsgText);
	SendReply($msgid,$to,$msgbody,$msgps,MSG_PVT | MSG_RRC,$message->FromUser,'RRQ - receipt');
}

function SendPING($message,$to,$origto,$msgid)
{
	InitVsysTrack($message,$to,$origto);
	SendReply($msgid,$to,$msgbody,$msgps,MSG_PVT,$message->FromUser,'Answer to your PING');
}

function ProcAfix($message,$to,$origto,$msgid)
{
	InitVsysTrack($message,$to,$origto);
	SendReply($msgid,$to,$msgbody,$msgps,MSG_PVT,$message->FromUser,'Reply from Areafix');
}

function NetMsgForUs($message,$orig,$dest,$msgid)
{
	GLOBAL $CONFIG;
	tolog('t',"New netmail message");
	$Attrs = FTS_to_Flag($message->Attr);
	if ($Attrs & MSG_RRQ):
		SendRRQ($message,$orig,$dest,$msgid);
	endif;
	if (strcasecmp($message->ToUser,'ping')==0):
		SendPING($message,$orig,$dest,$msgid);
	endif;
	if (strcasecmp($message->ToUser,'areafix')==0):
		ProcAfix($message,$orig,$dest,$msgid);
	endif;
	if ($CONFIG->Areas->Vals):
		foreach ($CONFIG->Areas->Vals as $area):
			if (strcmp($area->Status,'netmailarea')==0):
				$areaname = $area->EchoTag;
				break;
			endif;
		endforeach;
	endif;
	if (!isset($areaname)):
		$areaname = 'Netmail';
		if (AutoCreateArea('NetMailArea','Netmail',false,'Autocreated netmail area')):
			tolog('T',"Created netmail area");
		else: 
			tolog('T',"Error creating netmail area");
			return 0;
		endif;
	endif;
	$Area = new C_msgbase;
	$Area->Open($areaname,1);
	$header = new C_msgheader;
	$header->Attrs = FTS_to_Flag(ZeroNFlags($message->Attr));
	$header->From = $message->FromUser;
	$header->To = $message->ToUser;
	$header->Subj = $message->Subject;
	$header->FromAddr = $orig;
	$header->ToAddr = $dest;
	$header->WDate = Fts_date_to_unix($message->AsciiDate);
	$header->ADate = mktime();
	$Area->WriteMessage($header,$message->MsgText);
	$Area->Close();
	tolog('t','Tossing message finished');
	return 1;
}

function Process_netmail_message($message,$from)
{
	GLOBAL $CONFIG;
	$MsgText = $message->MsgText;
	$Attr = FTS_to_Flag($message->Attr);
	list($orig,$dest,$msgid) = GetNetMsgOrigDest($MsgText);
	$forus = 0;
	foreach($CONFIG->GetArray('address') as $addr):
		if (strcmp($addr,$dest)==0):
			$forus = 1;
			break;
		endif;
	endforeach;
	if ($forus):
		$res = NetMsgForUs($message,$orig,$dest,$msgid);
	else:
		if (FTS_to_Flag($message->Attr) & MSG_ARQ):
			SendARQ($message,$orig,$dest,$msgid);
		endif;
		$addr = RouteMsg($dest);
		$MessageText = AddVia($message->MsgText,$CONFIG->GetVar('address'));
		$Omessage = new Pkt_message;
		$Omessage->Version = 2;
		$Omessage->OrigNode = $message->OrigNode;
		$Omessage->DestNode = $message->DestNode;
		$Omessage->OrigNet = $message->OrigNet;
		$Omessage->DestNet = $message->DestNet;
		$Omessage->Attr = ZeroNFlags($message->Attr);
		$Omessage->Cost = $message->Cost;
		$Omessage->AsciiDate = $message->AsciiDate;
		$Omessage->ToUser = $message->ToUser;
		$Omessage->FromUser = $message->FromUser;
		$Omessage->Subject = $message->Subject;
		$Omessage->MsgText = $MessageText;
		PackMessageTo($Omessage,$addr);
		$res = 1;
	endif;
	return $res;
}

function RouteMsg($toaddr)
{
	GLOBAL $CONFIG;
	$dest = GetFidoAddr($toaddr);
	foreach($CONFIG->GetArray('route') as $route):
		$ifs = split(' ',$route);
		$ifto = array_shift($ifs);
		foreach($ifs as $if):
			if ($if = trim($if)):
				$zone = strtok($if,':');
				if (strcmp($zone,'*')==0):
					return $ifto;
				elseif ($zone == $dest[0]):
					$net = strtok('/');
					if (strcmp($net,'*')==0):
						return $ifto;
					elseif ($net == $dest[1]):
						$node = strtok('.');
						if (strcmp($node,'*')==0):
							return $ifto;
						elseif ($node == $dest[2]):
							$point = strtok('');
							if (strcmp($point,'*')==0):
								return $ifto;
							elseif ($point == $dest[3]):
								return $ifto;
							endif;
						endif;
					endif;
				endif;
			endif;
		endforeach;
	endforeach;
	return false;
}

function AddVia($text,$addr)
{
	if ($text !== false):
		$p = strlen($text);
		while(strcmp($text{$p-1},"\r")==0) $p--;
		$text = substr($text,0,$p);
	endif;
	$text.= "\r".chr(1)."Via $addr @".date('Ymd.His').' Phfito/0.75'."\r";
	return $text;
}

function ScanNetMessage($area,$msg,$Area = false,$header = false)
{
	GLOBAL $CONFIG;
	$openb = $Area === false;
	$areanum = $CONFIG->Areas->FindAreaNum($area);
	if ($openb):
		$Area = new C_msgbase;
		$Area->Open($area);
	endif;
	if ($header === false) $header = $Area->ReadMsgHeader($msg);
	$MessageText = $Area->ReadMsgBody($msg);
	if ($header->FromAddr && $header->ToAddr):
		$FromAddr = $header->FromAddr;
		$ToAddr = $header->ToAddr;
	else:
		list($FromAddr,$ToAddr) = GetNetMsgOrigDest($MessageText);
	endif;
	$addr = RouteMsg($ToAddr);
	$MessageText = AddVia($MessageText,$CONFIG->GetVar('address'));
	preg_match('/:([0-9]+)\/([0-9]+)/',$FromAddr,$m);
	preg_match('/:([0-9]+)\/([0-9]+)/',$ToAddr,$t);
	$Omessage = new Pkt_message;
	$Omessage->Version = 2;
	$Omessage->OrigNode = $m[1];
	$Omessage->DestNode = $m[2];
	$Omessage->OrigNet = $t[1];
	$Omessage->DestNet = $t[2];
	$Omessage->Attr = ZeroNFlags(Flag_to_FTS($header->Attrs));
	$Omessage->Cost = 0;
	$Omessage->AsciiDate = date('d M y  H:i:s',$header->WDate);
	$Omessage->ToUser = $header->To;
	$Omessage->FromUser = $header->From;
	$Omessage->Subject = $header->Subj;
	$Omessage->MsgText = $MessageText;
	PackMessageTo($Omessage,$addr);
	if ($openb):
		$Area->Close();
	endif;
}

?>
