<?

function Sort_nodes($a,$b)
{
	list($n1,$f1) = split('/',$a);
	list($n2,$f2) = split('/',$b);
	$r = $n1 - $n2;
	if ($r == 0)
		$r = $f1 - $f2;
	return $r;
}

function DupeCheck($area,$msgid)
{
	GLOBAL $CONFIG;
	$area = strtolower($area);
	if (!$msgid) return 0;
	$crc = crc32($msgid);
	if ($base = $CONFIG->GetVar('dupebase')):
		if ((is_file($base.'/'.$area)) && ($f = fopen($base.'/'.$area,'r'))):
			while(!feof($f)):
				$nc = fgetint($f,4);
				if ($crc == $nc):
					fclose($f);
					return 1;
				endif;
			endwhile;
			fclose($f);
			return 0;
		endif;
	else:
		return 0;
	endif;
}

function DupeAdd($area,$msgid)
{
	GLOBAL $CONFIG;
	$area = strtolower($area);
	if (!$msgid) return 0;
	$crc = crc32($msgid);
	if ($base = $CONFIG->GetVar('dupebase')):
		if ($f = fopen($base.'/'.$area,'a')):
			fputint($f,4,$crc);
			fclose($f);
		endif;
	endif;
}

function join_to_80_wpp($array,$prefix)
{
	$strs='';
	$item = array_shift($array);
	while ($item):
		$line = $prefix.$item;
		$item = '';
		while ($array):
			$item = array_shift($array);
			if (strlen($line.' '.$item)>80):
				break;
			else:
				$line.= ' '.$item;
				$item = '';
			endif;
		endwhile;
		$strs.= $line."\r";
	endwhile;
	return $strs;
}

function AddSeenByAndPath($message,$links,$ouraka,$from,$to)
{
	GLOBAL $CONFIG;
	$path = '';
	$seenby = '';
	$resmsg = '';
	$sepmsg = '';
	$wpath = false;
	$message = str_replace("\r","\r".chr(0),$message);
	$line = strtok($message,"\r");
	while($line):
		if (strcmp(substr($line,0,1),chr(0))==0) $line = substr($line,1);
		if (strcmp(substr($line,0,7),chr(1).'PATH: ')==0):
			$path = trim(substr($line,7));
			$wpath = true;
			break;
		elseif (strcmp(substr($line,0,9),'SEEN-BY: ')==0):
			$sepmsg.= $line."\r";
			$seenby.= ($seenby?' ':'').trim(substr($line,9));
		else:
			$resmsg.= $sepmsg.$line."\r";
			$sepmsg = '';
			$seenby = '';
			$path = '';
		endif;
		$line = strtok("\r");
	endwhile;

//	$resmsg = '123123';

	$seens = $seenby?(split(' ',$seenby)):array();
	$paths = $path?(split(' ',$path)):array();
	$szs = sizeof($seens);
	$szp = sizeof($paths);
	for ($i=0; $i<$szs; $i++):
		$p = strpos($seens[$i],'/');
		if ($p === false):
			$seens[$i] = $net.'/'.$seens[$i];
		else:
			$net = substr($seens[$i],0,$p);
		endif;
	endfor;
	$zg = false;
	$tozone = false;
	if (!$CONFIG->GetVar('nozonegating')):
		$zg = true;
		$zone = false;
		$tozone = false;
		if (($p = strpos($from,':'))!==false):
			$zone = substr($from,0,$p);
		elseif (($p = strpos($ouraka,':'))!==false):
			$zone = substr($ouraka,0,$p);
		endif;
		if (($p = strpos($to,':'))!==false):
			$tozone = substr($to,0,$p);
		endif;
		$strip = ($zone && $tozone && ($zone != $tozone));
		if ($strip) $seens = array();
	endif;
	$l2 = $links;
	if (!in_array($ouraka,$l2)) $l2[] = $ouraka;
	foreach($l2 as $l):
		$zone = strtok($l,':');
		$net = strtok('/');
		$node = strtok('.');
		$point = strtok('@');
		if (!$point):
			if (!$tozone || ($zone == $tozone) || !$zg):
				if (!in_array($addr2d = $net.'/'.$node,$seens)):
					$seens[] = $addr2d;
				endif;
			endif;
		endif;
	endforeach;
	usort($seens,'Sort_nodes');

	for ($i=0; $i<$szp; $i++):
		$p = strpos($paths[$i],'/');
		if ($p === false):
			$paths[$i] = $net.'/'.$paths[$i];
		else:
			$net = substr($paths[$i],0,$p);
		endif;
	endfor;
	$zone = strtok($ouraka,':');
	$net = strtok('/');
	$node = strtok('.');
	$point = strtok('@');
	if (!$point):
		if ((sizeof($paths)==0) || (strcmp($paths[$szp-1],$addr2d = $net.'/'.$node)!=0)):
			$paths[] = $addr2d;
		endif;
	endif;

	$seenby = join_to_80_wpp($seens,'SEEN-BY: ');
	$path = join_to_80_wpp($paths,chr(1).'PATH: ');
	if (!$wpath) $resmsg.= $sepmsg.$line;
	$p = strlen($resmsg);
	while(strcmp($resmsg{$p-1},"\r")==0) $p--;
	while(strcmp($resmsg{$p-1},chr(0))==0) $p--;
	while(strcmp($resmsg{$p-1},"\r")==0) $p--;
	$resmsg = substr($resmsg,0,$p);
	return $resmsg."\r".$seenby.$path;
}

function Process_echomail_message($message,$addr,$area)
{
	GLOBAL $CONFIG;
	$MsgText = $message->MsgText;
	list($Origin_addr,$dest,$msgid) = GetEchoMsgOrigDest($MsgText);
	if (DupeCheck($area,$msgid)):
		tolog('t',"Dupe message in area $area");
		return 0;
	endif;
	tolog('t',"New message in area $area");
	if (($areanum = $CONFIG->Areas->FindAreaNum($area))==-1):
		if (AutoCreateArea('EchoArea',$area,$addr)):
			tolog('T',"Created area $area");
		else:
			tolog('T',"Could not create area $area");
			return 0;
		endif;
	endif;
	
	if (isset($CONFIG->Areas->Vals)):
		$num = $CONFIG->Areas->FindAreaNum($area);
		if ($num == -1) return 0;
		if (in_array($addr,$CONFIG->Areas->Vals[$num]->Links)):
			foreach ($CONFIG->Areas->Vals[$num]->Links as $packto):
			if (strcmp($addr,$packto)!=0):
				tolog('k',"Packing message for $packto");
				$Omessage = new Pkt_message;
				$Omessage->Version = 2;
				$Omessage->OrigNode = $message->OrigNode;
				$Omessage->DestNode = $message->DestNode;
				$Omessage->OrigNet = $message->OrigNet;
				$Omessage->DestNet = $message->DestNet;
				$Omessage->Attr = ZeroNFlags($message->Attr);
				$Omessage->Cost = $message->Cost;
				$Omessage->AsciiDate = $message->AsciiDate;
				$Omessage->ToUser = $message->ToUser;
				$Omessage->FromUser = $message->FromUser;
				$Omessage->Subject = $message->Subject;
				$Text = AddSeenByAndPath($message->MsgText,$CONFIG->Areas->Vals[$num]->Links,$CONFIG->GetVar('address'),$addr,$packto);
				$Omessage->MsgText = $Text;
				PackMessageTo($Omessage,$packto);
				tolog('k','Packing finished');
			endif;
			endforeach;
		else:
			tolog('t','Bad message');
			return 0;
		endif;
	endif;
	
	$Area = new C_msgbase;
	if ($Area->Open($area,1)):
		$header = new C_msgheader;
		$header->Attrs = FTS_to_Flag(ZeroNFlags($message->Attr));
		$header->From = $message->FromUser;
		$header->To = $message->ToUser;
		$header->Subj = $message->Subject;
		$header->FromAddr = $Origin_addr;
		$header->ToAddr = 0;
		$header->WDate = Fts_date_to_unix($message->AsciiDate);
		$header->ADate = mktime();
		$Area->WriteMessage($header,$MsgText);
		$Area->Close();
		DupeAdd($area,$msgid);
		tolog('t','Tossing message finished');
		return 1;
	else:
		tolog('T',"Could not open area $area!");
		return 0;
	endif;
}

function ScanMessage($area,$msg,$Area = false,$header = false)
{
	$openb = $Area === false;
	GLOBAL $CONFIG;
	$areanum = $CONFIG->Areas->FindAreaNum($area);
	if (!$CONFIG->Areas->Vals[$areanum]->Links):
		tolog('K','Nobody to pack');
	else:
		if ($openb):
			$Area = new C_msgbase;
			$Area->Open($area);
		endif;
		if ($header === false) $header = $Area->ReadMsgHeader($msg);
		$MessageText = "AREA: ".strtoupper($area)."\r".chr(1).'TID: Phfito 0.075'."\r".$Area->ReadMsgBody($msg);
		if ($header->FromAddr && $header->ToAddr):
			$FromAddr = $header->FromAddr;
			$ToAddr = $header->ToAddr;
		else:
			list($FromAddr,$ToAddr) = GetEchoMsgOrigDest($MessageText);
		endif;
		preg_match('/:([0-9]+)\/([0-9]+)/',$FromAddr,$m);
		preg_match('/:([0-9]+)\/([0-9]+)/',$ToAddr,$t);
		foreach($CONFIG->Areas->Vals[$areanum]->Links as $addr):
			$NewMessageText = AddSeenByAndPath($MessageText,$CONFIG->Areas->Vals[$areanum]->Links,$CONFIG->GetVar('address'),'',$addr);
			tolog('k',"Packing pkt for $addr");
			$Omessage = new Pkt_message;
			$Omessage->Version = 2;
			$Omessage->OrigNode = $m[1];
			$Omessage->DestNode = $m[2];
			$Omessage->OrigNet = $t[1];
			$Omessage->DestNet = $t[2];
			$Omessage->Attr = ZeroNFlags(Flag_to_FTS($header->Attrs));
			$Omessage->Cost = 0;
			$Omessage->AsciiDate = date('d M y  H:i:s',$header->WDate);
			$Omessage->ToUser = $header->To;
			$Omessage->FromUser = $header->From;
			$Omessage->Subject = $header->Subj;
			$Omessage->MsgText = $NewMessageText;
			PackMessageTo($Omessage,$addr);
			tolog('k','Packing finished');
		endforeach;
		if ($openb):
			$Area->Close();
		endif;
	endif;
}

?>
