<?

function GetEchoMsgOrigDest($message)
{
	$message = str_replace("\r","\r".chr(0),$message);
	$dest = '0:0/0.0';
	$orig = false;
	$msgid = '';
	$origin = '';
	$line = strtok($message,"\r");

	while($line):
		if (strcmp(substr($line,0,1),chr(0))==0) $line = substr($line,1);
		if (strcmp(substr($line,0,1),chr(1))==0):
			if (!$msgid && (strcasecmp(substr($line,1,7),'MSGID: ')==0)):
				$msgid = trim(substr($line,8));
			endif;
		else:
			break;
		endif;
		$line = strtok("\r");
	endwhile;
	$line = chr(0).$line;
	while($line):
		if (strcmp(substr($line,0,1),chr(0))==0) $line = substr($line,1);
		if (strcmp(substr($line,0,11),' * Origin: ')==0):
			$origin = trim(substr($line,11));
		endif;
		$line = strtok("\r");
	endwhile;
	if ($origin):
		$rp = strrpos($origin,'(');
		$origin = substr($origin,$rp+1);
		$orig = JoinFidoAddr(GetFidoAddr($origin));
	endif;
	if ($orig === false):
		if ($msgid) $orig = JoinFidoAddr(GetFidoAddr($msgid));
	endif;
	if ($orig === false):
		$orig = '0:0/0.0';
	endif;
	return array($orig,$dest,$msgid);
}

function GetNetMsgOrigDest($message)
{
	GLOBAL $CONFIG;
	$message = str_replace("\r","\r".chr(0),$message);
	$intl = '';
	$topt = '';
	$fmpt = '';
	$origin = '';
	$msgid = '';
	
	$line = strtok($message,"\r");
	while($line):
		if (strcmp(substr($line,0,1),chr(0))==0) $line = substr($line,1);
		if (strcmp(substr($line,0,1),chr(1))==0):
			if (!$msgid && (strcasecmp(substr($line,1,7),'MSGID: ')==0)):
				$msgid = trim(substr($line,8));
			elseif (!$intl && (strcasecmp(substr($line,1,5),'INTL ')==0)):
				$intl = trim(substr($line,6));
			elseif (!$topt && (strcasecmp(substr($line,1,5),'TOPT ')==0)):
				$topt = trim(substr($line,6));
			elseif (!$fmpt && (strcasecmp(substr($line,1,5),'FMPT ')==0)):
				$fmpt = trim(substr($line,6));
			endif;
		else:
			break;
		endif;
		$line = strtok("\r");
	endwhile;
	$line = chr(0).$line;
	while($line):
		if (strcmp(substr($line,0,1),chr(0))==0) $line = substr($line,1);
		if (strcmp(substr($line,0,11),' * Origin: ')==0):
			$origin = trim(substr($line,11));
		endif;
		$line = strtok("\r");
	endwhile;
	$orig = false;
	$dest = false;
	if ($intl):
		list($dest,$orig) = split(' ',$intl);
		if ($fmpt) $orig.= '.'.$fmpt;
		if ($topt) $dest.= '.'.$topt;
	endif;
	if ($orig === false):
		if ($msgid) $orig = JoinFidoAddr(GetFidoAddr($msgid));
	endif;
	if ($orig === false):
		if ($origin):
			$rp = strrpos($origin,'(');
			$origin = substr($origin,$rp+1);
			$orig = JoinFidoAddr(GetFidoAddr($origin));
		endif;
	endif;
	return array($orig,$dest,$msgid);
}

function JoinFidoAddr($addr)
{
	return $addr[0].':'.$addr[1].'/'.$addr[2].($addr[3]?'.'.$addr[3]:'');
}

function GetFidoAddr($string)
{
	if (preg_match('/(\d+)\:(\d+)\/(\d+)(\.(\d+))?/',$string,$msv)):
		$res[0] = (int)$msv[1];
		$res[1] = (int)$msv[2];
		$res[2] = (int)$msv[3];
		$res[3] = (isset($msv[5])?(int)$msv[5]:0);
		return $res;
	else:
		return false;
	endif;
}

function get_initials($name)
{
	if (strlen($name)<4) return $name;
	$result = '';
	$word = strtok($name,' _');
	while ($word):
		$result.= substr($word,0,1);
		$word = strtok(' _');
	endwhile;
	if (strlen($result)>3) return substr($result,0,3);
	return $result;
}

function format_reply($message,$inits,$delim = '>',$viewcl = 0)
{
 $message=str_replace(chr(13),chr(13).chr(0),$message);
 $txt=strtok($message,chr(13));
 while ($txt):
  $text_ms[]=str_replace(chr(0),'',$txt);
  $txt=strtok(chr(13));
 endwhile;
for ($i=sizeof($text_ms)-1;$i>=0;$i--):
  if (strcmp(substr($text_ms[$i],0,1),chr(1))==0):
   if ($viewcl) :
    $text_ms[$i][0]="@";
   else :
    $text_ms=del_elem($text_ms,$i);
   endif;
  elseif (strcasecmp(substr($text_ms[$i],0,8),'seen-by:')==0):
   if (!$viewcl) :
    $text_ms=del_elem($text_ms,$i);
   endif;
  endif;
 endfor;
 
   $s = sizeof($text_ms);
   for ($i=0; $i<$s; $i++) 
   {   
	   
   $prefix = '';	   
   $lend = strlen($delim);
   if ($t=strpos($text_ms[$i],$delim)):
   $quotelvl=0;
   for ($j=$t;strcasecmp(substr($text_ms[$i],$j,$lend),$delim)==0;$j+=$lend) {$quotelvl++;}
   if (preg_match('/^([0-9 A-Za-z]*)$/',substr($text_ms[$i],0,$t-1))):
  
    $prefix = substr($text_ms[$i],0,$t+$quotelvl*$lend);
    $text_ms[$i] = substr($text_ms[$i],$t+$quotelvl*$lend);
   endif;
   endif;

	$msv=split("\n",cut_to_80($text_ms[$i],77-strlen($inits))); 
	foreach ($msv as $item):
   		$text_ms1[] = $prefix.$item;
	endforeach;
    }
//    $text_ms = '';
    $text_ms = $text_ms1;
    unset($text_ms1);

 $s = sizeof($text_ms);
 for ($i=0; $i<$s; $i++): if (trim($text_ms[$i])) {   
 
if (($t=strpos($text_ms[$i],$delim))!==false):
   $quotelvl=0;
   for ($j=$t;strcasecmp(substr($text_ms[$i],$j,$lend),$delim)==0;$j+=$lend) {$quotelvl++;}
   
  if (preg_match('/^([0-9 A-Za-z]*)$/',substr($text_ms[$i],0,$t))):
    $text_ms[$i]=substr($text_ms[$i],0,$t).$delim.substr($text_ms[$i],$t);
   else:
    $text_ms[$i]=' '.$inits.$delim.' '.$text_ms[$i];
   endif;
else:
   $text_ms[$i]=' '.$inits.$delim.' '.$text_ms[$i];
endif;
   
}
endfor;

 $message=implode("\n",$text_ms);
 return $message;
}

function del_elem($arr,$num)
{
 for ($i=0;$i<sizeof($arr);$i++):
  if ($i!=$num) {$rez[]=$arr[$i];}
 endfor;
 return $rez;
}

function cut_to_80($item,$charcnt)
{
	$result='';
	while (strlen($item)>$charcnt):
		$str80=substr($item,0,$charcnt);
		if (($pos=strrpos($str80,' '))>0):
			$result.=substr($item,0,$pos)."\n";
			$item=substr($item,$pos+1);
		else:
			$result.=$str80."\n";
			$item=substr($item,$charcnt);
		endif;
	endwhile;
	return $result.$item;
}

?>
